package com.yunzhi.shigongli.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.yunzhi.shigongli.common.StringUtils;
import com.yunzhi.shigongli.entity.TaShopImages;
import com.yunzhi.shigongli.mapper.TaShopImagesMapper;
import com.yunzhi.shigongli.service.ITaShopImagesService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 商铺图片 服务实现类
 * </p>
 *
 * @author yansen
 * @since 2021-08-17
 */
@Service
public class TaShopImagesServiceImpl extends BaseServiceImpl<TaShopImagesMapper, TaShopImages> implements ITaShopImagesService {

    @Autowired
    TaShopImagesMapper taShopImagesMapper;


    @Override
    public void updateImages(String shopId, List<TaShopImages> imageList) throws Exception {
        if (null == imageList) {
            throw new Exception("未找到图片列表信息");
        }

        if (StringUtils.isEmpty(shopId)) {
            throw new Exception("未找到有效的商铺信息");
        }

        // 先删除所有的
        removeByShop(shopId);

        // 再插入新记录
        for (TaShopImages image: imageList) {
            image.setImageId(null);
            image.setShopId(shopId);
        }

        saveBatch(imageList);
    }

    private boolean removeByShop(String shopId) throws Exception {
        LambdaQueryWrapper<TaShopImages> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(TaShopImages::getShopId, shopId);

        return remove(queryWrapper);
    }
}
